/*
 * linux-no-exec-stack-lkm 0.1
 *  Copyright (c) 2002-2003 By Next Generation Security S.L.
 *
 * By:
 *  
 *  Fermn J. Serna <fjserna@ngsec.com>
 *  aka Zhodiac     <zhodiac@net-dreamer.net>
 *
 * Madrid, August 2003 
 */


#define MODULE
#define __KERNEL__

#include<linux/module.h>
#include<linux/init.h>
#include<linux/kernel.h>

#define GDT_USER_CODE 4

EXPORT_NO_SYMBOLS;

// Borrowed from OBSD kernel 
struct segment_descriptor {
        unsigned sd_lolimit:16;         /* segment extent (lsb) */
        unsigned sd_lobase:24;          /* segment base address (lsb) */ 
        unsigned sd_type:5;             /* segment type */
        unsigned sd_dpl:2;              /* segment descriptor priority level */
        unsigned sd_p:1;                /* segment descriptor present */
        unsigned sd_hilimit:4;          /* segment extent (msb) */
        unsigned sd_xx:2;               /* unused */
        unsigned sd_def32:1;            /* default 32 vs 16 bit size */
        unsigned sd_gran:1;             /* limit granularity (byte/page) */
        unsigned sd_hibase:8;           /* segment base address (msb) */
} __attribute__((__packed__));

struct segment_descriptor *gdt0;

int my_init(void) {
 unsigned char gdtaddr[6];
 
      __asm__ volatile("sgdt %0": "=m"(gdtaddr));
 
      gdt0=(struct segment_descriptor *)*(unsigned *)(gdtaddr+2);

#ifdef DEBUG
      printk(KERN_ALERT "GDT table address %x\n",(unsigned long)gdt0);
#endif

      gdt0[GDT_USER_CODE].sd_hilimit=0xB;
      gdt0[GDT_USER_CODE].sd_lolimit=0xF7FF;

      printk(KERN_ALERT "NGSEC's no-exec stack protection installed. Comments\n");

      return 0;
}


void my_exit(void)
{

      gdt0[GDT_USER_CODE].sd_hilimit=0xF;
      gdt0[GDT_USER_CODE].sd_lolimit=0xFFFF;


      printk(KERN_ALERT "NGSEC's no-exec stack protection Uninstalled\n");
}

module_init(my_init);
module_exit(my_exit);

